api/urls.py
from django.urls import path

from . import views
from graphs import views as graph_views


app_name = 'api'
urlpatterns = [
    path('datasets', views.dataset_list, name='dataset-list'),
    path('dataset/<slug>', views.dataset_detail, name='dataset-detail'),
    path('dataset/<slug>/<tablename>/data', views.dataset_data, name='dataset-table-data'),
    path('especiais/grafo/sociedades', graph_views.GetResourceNetworkView.as_view(), name='resource-graph'),
    path('especiais/grafo/sociedades/caminhos', graph_views.GetPartnershipPathsView.as_view(), name='partnership-paths'),
    path('especiais/grafo/sociedades/subsequentes', graph_views.GetCompanySubsequentPartnershipsGraphView.as_view(), name='subsequent-partnerships'),
    path('especiais/grafo/sociedades/empresas-mae', graph_views.CNPJCompanyGroupsView.as_view(), name='company-groups'),
    path('especiais/grafo/no', graph_views.GetNodeDataView.as_view(), name='node-data'),
]

brasilio/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/', include('api.urls', namespace='api')),
    path('auth/', include('brasilio_auth.urls', namespace='brasilio_auth')),
    path('', include('core.urls', namespace='core')),
]

brasilio_auth/urls.py
from django.urls import reverse_lazy
from django.contrib.auth import views as auth_views
from django.urls import path

from brasilio_auth.views import CreateUserView


views_config = {
    'login': auth_views.LoginView.as_view(template_name='brasilio_auth/login.html'),
    'logout': auth_views.LogoutView.as_view(),
    'password_reset': auth_views.PasswordResetView.as_view(
        template_name='brasilio_auth/password_reset.html',
        success_url=reverse_lazy('brasilio_auth:password_reset_done'),
        email_template_name='brasilio_auth/emails/password_reset_email.html',
        subject_template_name='brasilio_auth/emails/password_reset_subject.txt',
    ),
    'password_reset_done': auth_views.PasswordResetDoneView.as_view(
        template_name='brasilio_auth/password_reset_done.html',
    ),
    'password_reset_confirm': auth_views.PasswordResetConfirmView.as_view(
        template_name='brasilio_auth/password_reset_form.html',
        success_url=reverse_lazy('brasilio_auth:password_reset_complete'),
    ),
    'password_reset_complete': auth_views.PasswordResetCompleteView.as_view(
        template_name='brasilio_auth/password_reset_complete.html',
    ),
}

app_name = 'brasilio_auth'
urlpatterns = (
    path('login/', views_config['login'], name='login'),
    path('logout/', views_config['logout'], name='logout'),
    path('troca-senha/', views_config['password_reset'], name='password_reset'),
    path('troca-senha/enviada/', views_config['password_reset_done'], name='password_reset_done'),
    path('troca-senha/<uidb64>/<token>/', views_config['password_reset_confirm'], name='password_reset_confirm'),
    path('troca-senha/atualizada/', views_config['password_reset_complete'], name='password_reset_complete'),
    path('logout/', views_config['logout'], name='logout'),
    path('entrar/', CreateUserView.as_view(), name='sign_up'),
)

brasilio_auth/models.py
from django.db import models
from django.contrib.auth import get_user_model


class NewsletterSubscriber(models.Model):
    user = models.OneToOneField(get_user_model(), on_delete=models.CASCADE)

brasilio_auth/forms.py
from django import forms
from django.contrib.auth import get_user_model
from django.contrib.auth.forms import UserCreationForm as DjangoUserCreationForm
from django.utils.translation import ugettext_lazy as _

from brasilio_auth.models import NewsletterSubscriber


class UserCreationForm(DjangoUserCreationForm):
    email = forms.EmailField()
    password1 = forms.CharField(label=_("Password"), widget=forms.PasswordInput)
    password2 = forms.CharField(
        label=_("Password confirmation"),
        widget=forms.PasswordInput,
        help_text=_("Enter the same password as above, for verification.")
    )
    subscribe_newsletter = forms.BooleanField(required=False)

    class Meta:
        model = get_user_model()
        fields = ('username', 'email')

    def save(self, *args, **kwargs):
        user = super(UserCreationForm, self).save(*args, **kwargs)
        if self.cleaned_data.get('subscribe_newsletter'):
            NewsletterSubscriber.objects.create(user=user)
        return user

brasilio_auth/views.py
from django.conf import settings
from django.contrib.auth import get_user_model, login
from django.views.generic.edit import CreateView
from django.shortcuts import redirect

from brasilio_auth.forms import UserCreationForm


class CreateUserView(CreateView):
    template_name = 'brasilio_auth/user_creation_form.html'
    model = get_user_model()
    form_class = UserCreationForm
    success_url = settings.LOGIN_REDIRECT_URL

    def get_context_data(self, *args, **kwargs):
        context = super(CreateUserView, self).get_context_data()
        next = self.request.GET.get('next', None)
        if next:
            context['next'] = next
        return context

    def form_valid(self, *args, **kwargs):
        super(CreateUserView, self).form_valid(*args, **kwargs)
        login(self.request, self.object)
        url = self.request.POST.get('next', None) or self.success_url
        return redirect(url)

brasilio_auth/templates/brasilio_auth/login.html
{% extends "base.html" %}

{% block content %}

{% if form.errors %}
<p>Senha inválida. Por favor tente novamente.</p>
{% endif %}

{% if next %}
    {% if user.is_authenticated %}
    <p>Seu usuário não possui permissão para acessar esta página. Para seguir, por favor utilize algum usuário com permissão.</p>
    {% else %}
    <p>Faça o login para acessar a página.</p>
    {% endif %}
{% endif %}

<form method="post" action="{% url 'brasilio_auth:login' %}">
{% csrf_token %}
<table>
<tr>
    <td>{{ form.username.label_tag }}</td>
    <td>{{ form.username }}</td>
</tr>
<tr>
    <td>{{ form.password.label_tag }}</td>
    <td>{{ form.password }}</td>
</tr>
</table>

<input class="btn" type="submit" value="login" />
<input type="hidden" name="next" value="{{ next }}" />
</form>

<p><a href="{% url 'brasilio_auth:password_reset' %}">Esqueci minha senha</a></p>

{% endblock %}

brasilio_auth/templates/brasilio_auth/password_reset.html
{% extends "base.html" %}

{% block content %}

{% if form.errors %}
    {{ form.errors }}
{% endif %}

<form method="post" action="{% url 'brasilio_auth:password_reset' %}">
{% csrf_token %}
<table>
<tr>
    <td>{{ form.email.label_tag }}</td>
    <td>{{ form.email }}</td>
</tr>
</table>

<input class="btn" type="submit" value="Reset" />
</form>

{% endblock %}

brasilio_auth/templates/brasilio_auth/password_reset_complete.html
{% extends "base.html" %}

{% block content %}

<h4>Senha atualizada!</h4>
<p>Sua senha foi atualizada! Agora você pode seguir e acessar o Brasil.IO de novo.</p>

<p><a href="{{ login_url }}">Login</a></p>

{% endblock %}

brasilio_auth/templates/brasilio_auth/password_reset_done.html
{% extends "base.html" %}

{% block content %}

<h4>Redefinição de senha enviada</h4>
<p>Se existir uma conta com o e-mail fornecido, você receberá, em breve, uma mensagem com as instruções para redefinição da sua senha. Verifique sua caixa de entrada.</p>
  
<p>Se você não receber um e-mail, por favor verifique se o endereço digitado é o mesmo que você usou para se registrar. Verifique também a sua pasta de spam.</p>

{% endblock %}

brasilio_auth/templates/brasilio_auth/password_reset_form.html
{% extends "base.html" %}

{% block content %}

<h4>Atualização de Senha</h4>

{% if validlink %}

<p>Por favor, informe sua nova senha duas vezes para que possamos verificar se você a digitou corretamente.</p>

<form method="post">{% csrf_token %}
    <div>
        {{ form.new_password1.errors }}
        <label for="id_new_password1">Nova senha:</label>
        {{ form.new_password1 }}
    </div>
    <div>
        {{ form.new_password2.errors }}
        <label for="id_new_password2">Confirmação de senha:</label>
        {{ form.new_password2 }}
    </div>
    <input class='btn' type="submit" value="Alterar minha senha" />
</form>

{% else %}

<p>O link para atualização de senha está inválido. Provavelmente você já o utilizou ou o link expirou. Por favor, solicite uma nova troca de senha.</p>

{% endif %}

{% endblock %}

brasilio_auth/templates/brasilio_auth/user_creation_form.html
{% extends "base.html" %}

{% block content %}

{% if next %}
{% include 'contas-gratuitas.html' %}
{% endif %}

<h4>Cadastre-se</h4>

<form method="post">{% csrf_token %}
    <div>
        {{ form.username.errors }}
        <label for="id_username">Usuário:</label>
        {{ form.username }}
    </div>
    <div>
        {{ form.email.errors }}
        <label for="id_email">Email:</label>
        {{ form.email }}
    </div>
    <div>
        {{ form.password1.errors }}
        <label for="id_password1">Senha:</label>
        {{ form.password1 }}
    </div>
    <div>
        {{ form.password2.errors }}
        <label for="id_password2">Confirmação de senha:</label>
        {{ form.password2 }}
    </div>
    <div>
      <label>
        {{ form.subscribe_newsletter }}
        <span>Deseja assinar nossa newsletter? </span>
      </label>
    </div>
    <input type="hidden" name="next" value="{{ next }}" />
    <input class='btn' type="submit" value="Salvar" />
</form>


{% endblock %}